<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/


// Session timeout
if (am_i_user()) {
	if (isset($_SESSION['last_active']) && $cfg['session_time'] > 0 && (time() - $_SESSION['last_active'] > $cfg['session_time'])) {
		// last request was more than $cfg_session_time
		if ($_SESSION['login']) {
			$content['status'][] = "Session timeout";
		}
		session_unset();	// unset $_SESSION variable for the run-time
		session_destroy();	// destroy session data in storage
	} // else simply rely on whatever the server's garbage collection policy is for timeout
	$_SESSION['last_active'] = time(); // update last activity time stamp
}


// user update
if (am_i_user()) {

	$user_id = $_SESSION['login']['uid'];
	$userdata = $cnx->select_row("*", "view_users", "WHERE `uid` = '$user_id'");
	unset($_SESSION['login']);

	$_SESSION['login']['uid'] = $userdata['uid'];
	$_SESSION['login']['domain_id'] = $userdata['domain_id'];
	$_SESSION['login']['user'] = $userdata['user'];
	$_SESSION['login']['email'] = $userdata['email'];
	$_SESSION['login']['domain'] = $userdata['domain'];
	if ($userdata['admin']) {
		$_SESSION['login']['admin'] = 1;
		$domains_q = $cnx->select("id, name", "virtual_domains");
		foreach ($domains_q as $k => $v) {
			$id = $v['id'];
			$_SESSION['login']['admin_of'][$id] = $v['name'];
		}
	}
	elseif ($userdata['admin_of_ids']) {
		$admin_of_ids = explode(",", $userdata['admin_of_ids']);
		$admin_of_names = explode(",", $userdata['admin_of_names']);
		$_SESSION['login']['admin_of'] = array_combine($admin_of_ids, $admin_of_names);
	}
}
?>
