<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/


$domain_id = $_GET['domain_id'];

// If we shouldn't be here, be sent to a 404 page
if (!am_i_admin_of($domain_id) AND !am_i_server_admin(2)) {
	four_o_four();
}

// List domain data
$content['accounts']['details']['domain'] = $cnx->select_row("*", "virtual_domains", "WHERE `id` ='$domain_id'");


if (am_i_admin_of($domain_id)) {

	// Delete accounts - Delete aliases
	if ($_GET['delete_account']) {
		if (is_valid_id($_GET['delete_account'])) {
			$deleted_account = $cnx->select_field("user", "virtual_users", "WHERE `id` ='".$_GET['delete_account']."' AND `domain_id` ='$domain_id'");
			if ($deleted_account AND $_GET['confirm']) {
				// delete
				$cnx->delete($_GET['delete_account'], "virtual_users", "id");
				$content['status'][] = "Account <strong>$deleted_account</strong> deleted";
			} else if ($deleted_account) {
				$content['accounts']['confirm_delete']['user'] = $deleted_account;
				$content['accounts']['confirm_delete']['confirm_link'] = genlink("page=accounts|domain_id=$domain_id|delete_account=".$_GET['delete_account']."|confirm=1");
				$content['accounts']['confirm_delete']['cancel_link'] = genlink("page=accounts|domain_id=$domain_id");
			} else {
				$content['errors'][] = "Account does not exist";
			}
		}
	} else if ($_GET['delete_alias']) {
		if (is_valid_id($_GET['delete_alias'])) {
			$deleted_alias = $cnx->select_field("source", "virtual_aliases", "WHERE `id` ='".$_GET['delete_alias']."' AND `domain_id` ='$domain_id'");
			if ($deleted_alias AND $_GET['confirm']) {
				// delete
				$cnx->delete($_GET['delete_alias'], "virtual_aliases", "id");
				$content['status'][] = "Account <strong>$deleted_alias</strong> deleted";
			} else if ($deleted_alias) {
				$content['accounts']['confirm_delete']['alias'] = $deleted_alias;
				$content['accounts']['confirm_delete']['confirm_link'] = genlink("page=accounts|domain_id=$domain_id|delete_alias=".$_GET['delete_alias']."|confirm=1");
				$content['accounts']['confirm_delete']['cancel_link'] = genlink("page=accounts|domain_id=$domain_id");
			} else {
				$content['errors'][] = "Account does not exist";
			}
		}
	} else if ($_GET['delete_ml'] AND domain_can_ml($domain_id)) {
		if (is_valid_id($_GET['delete_ml'])) {
			$deleted_ml = $cnx->select_field("ml", "virtual_mailing_lists", "WHERE `id` ='".$_GET['delete_ml']."' AND `domain_id` ='$domain_id'");
			if ($deleted_ml AND $_GET['confirm']) {
				// delete
				$cnx->delete($_GET['delete_ml'], "virtual_mailing_lists", "id");
				$content['status'][] = "Account <strong>$deleted_ml</strong> deleted";
			} else if ($deleted_ml) {
				$content['accounts']['confirm_delete']['ml'] = $deleted_ml;
				$content['accounts']['confirm_delete']['confirm_link'] = genlink("page=accounts|domain_id=$domain_id|delete_ml=".$_GET['delete_ml']."|confirm=1");
				$content['accounts']['confirm_delete']['cancel_link'] = genlink("page=accounts|domain_id=$domain_id");
			} else {
				$content['errors'][] = "ML does not exist";
			}
		}
	}

	// Get policies - used by 'edit_domain' and 'add_account' forms
	$policies_array = $cnx->select(array('id', 'policy_name'), "policy");
	foreach ($policies_array as $k => $v) {
		$policy_select .= $v['id']."=".$v['policy_name'].":";
	}

	// Edit domain - Form + POST
	$edit_domain_form = new FormMaker("edit_domain", genlink("page=accounts|domain_id=$domain_id"));

	$edit_domain_form->add_element("name", "text", "custom|$reg_domain", 1);
	$edit_domain_form->set_display_name("name", "Domain name");
	if (!am_i_server_admin()) {
		$edit_domain_form->set_display_only("name");
		$edit_domain_form->set_value("name", $content['accounts']['details']['domain']['name']);
	 }

	$edit_domain_form->add_element("default_policy", "select", "monoselect|$policy_select", 1);
	$edit_domain_form->set_display_name("default_policy", "Default scan policy");

	$edit_domain_form->add_element("default_quota_kb", "text", "integer|127", 1);
	$edit_domain_form->set_display_name("default_quota_kb", "Default quota");
	$edit_domain_form->add_input_desc("default_quota_kb", " MB");

	$edit_domain_form->add_element("default_mail", "checkbox", "bool");
	$edit_domain_form->set_display_name("default_mail", "Default email");
	//$edit_domain_form->set_value("default_mail", 1);

	$edit_domain_form->add_element("default_xmpp", "checkbox", "bool");
	$edit_domain_form->set_display_name("default_xmpp", "Default XMPP");
	//$edit_domain_form->set_value("default_xmpp", 1);

	if (am_i_server_admin() AND $cfg['ml']) {
		$edit_domain_form->add_element("ml", "checkbox", "bool");
		$edit_domain_form->set_display_name("ml", "Mailing lists");
	}

	// POST
	if ($_POST['edit_domain']) {
		$edit_domain_form->check_post($_POST);
		if (!$edit_domain_form->errors()) {
			$form_results = $edit_domain_form->get_values();
			// Fix quota
			$form_results['default_quota_kb'] = $form_results['default_quota_kb'] * 1024;
			// Fix bool vars that are unset/empty -> 0
			foreach($form_results AS $k => $v) {
				if (in_array($k, array('default_mail', 'default_xmpp')) AND empty($v)) {
					$form_results[$k] = 0;
				}
			}

			$edit_domain = $cnx->update($form_results, "virtual_domains", $domain_id);
			if ($edit_domain) {
				$content['status'][] = "Updated";
				$content['accounts']['details']['domain'] = $cnx->select_row("*", "virtual_domains", "WHERE `id` ='$domain_id'");
			} else {
				$content['errors'][] = "Form contains errors";
			}
		} else {
			// ERROR
			$content['errors'][] = "Form contains errors";
		}
	} else {
		// Set domain's default values into form
		$edit_domain_form->set_value_and_validate("name", $content['accounts']['details']['domain']['name']);
		$edit_domain_form->set_value_and_validate("default_policy", $content['accounts']['details']['domain']['default_policy']);
		$edit_domain_form->set_value("default_quota_kb", ($content['accounts']['details']['domain']['default_quota_kb'] / 1024));
		$edit_domain_form->set_value_and_validate("default_mail", $content['accounts']['details']['domain']['default_mail']);
		$edit_domain_form->set_value_and_validate("default_xmpp", $content['accounts']['details']['domain']['default_xmpp']);
		$edit_domain_form->set_value_and_validate("ml", $content['accounts']['details']['domain']['ml']);
	}
	$content['accounts']['forms']['edit_domain_form'] = $edit_domain_form->result();

	// Add account - Form + POST
	$add_account_form = new FormMaker("add_account", genlink("page=accounts|domain_id=$domain_id"));
	$add_account_form->add_element("user", "text", "custom|$reg_account", 1);
	$add_account_form->set_display_name("user", "Email");
	$add_account_form->add_input_desc("user", "@".$content['accounts']['details']['domain']['name']);
	$add_account_form->add_element("password", "password", "free|127", 1);
	$add_account_form->set_display_name("password", "Password");
	$add_account_form->add_element("policy_id", "select", "monoselect|$policy_select", 1);
	$add_account_form->set_display_name("policy_id", "Scan policy");
	// Quota, mail, xmpp
	$add_account_form->add_element("quota_kb", "text", "integer|127");
	$add_account_form->set_display_name("quota_kb", "Quota");
	$add_account_form->add_input_desc("quota_kb", " MB");
	$add_account_form->add_element("mail", "checkbox", "bool");
	$add_account_form->set_display_name("mail", "Email");
	$add_account_form->set_value("mail", 1);
	$add_account_form->add_element("xmpp", "checkbox", "bool");
	$add_account_form->set_display_name("xmpp", "XMPP");
	$add_account_form->set_value("xmpp", 1);
	// Admin of domains
	if (is_array($_SESSION['login']['admin_of'])) {
		foreach ($_SESSION['login']['admin_of'] as $k => $v) {
			$admin_domain_select .= "$k=$v:";
		}
		$add_account_form->add_element("admin_of_ids", "checkbox", "multiselect|$admin_domain_select");
		$add_account_form->set_display_name("admin_of_ids", "Administer");
	}
	// Server admin
	if (am_i_admin()) {
		$add_account_form->add_element("admin", "checkbox", "bool");
		$add_account_form->set_display_name("admin", "Server admin");
		$add_account_form->set_value("admin", 1);
	}
	// Suspend
	if (am_i_admin_of($domain_id)) {
		$add_account_form->add_element("suspend", "checkbox", "bool");
		$add_account_form->set_display_name("suspend", "Suspend");
		$add_account_form->set_value("suspend", 1);
	}
	// POST
	if ($_POST['add_account']) {
		$add_account_form->check_post($_POST);
		if (!$add_account_form->errors()) {
			$form_results = $add_account_form->get_values();
			// Separate admin stuff
			$admin_of_array = explode(":", $form_results['admin_of_ids']);
			unset($form_results['admin_of_ids']);
			// Fix password - use function
			$form_results['password'] = crypt_password($form_results['password']);
			// Fix quota
			$form_results['quota_kb'] = $form_results['quota_kb'] * 1024;
			// Fix domain id
			$form_results['domain_id'] = $domain_id;
			$new_user_id = $cnx->insert($form_results, "virtual_users");
			if (is_valid_id($new_user_id)) {
				// Assign admin perms if applicable
				if (is_array($admin_of_array)) {
					foreach ($admin_of_array as $domid) {
						$cnx->insert(array('user_id' => $new_user_id, 'domain_id' => $domid), "domain_admin_assoc");
					}
				}
				$content['status'][] = "User <strong>".$form_results['user']."</strong> added";
				// Reset vals
				$add_account_form->set_value("user", "");
				$add_account_form->set_value("password", "");
				$add_account_form->set_value("admin_of_ids", "");
			} else {
				$content['errors'][] = "Error while adding new user";
				$content['errors'][] = $new_user_id;
			}
		} else {
			$content['errors'][] = "Form contains errors";
		}
	} else {
		// Set domain's default values into form
		$add_account_form->set_value_and_validate("policy_id", $content['accounts']['details']['domain']['default_policy']);
		$add_account_form->set_value("quota_kb", ($content['accounts']['details']['domain']['default_quota_kb'] / 1024));
		$add_account_form->set_value_and_validate("mail", $content['accounts']['details']['domain']['default_mail']);
		$add_account_form->set_value_and_validate("xmpp", $content['accounts']['details']['domain']['default_xmpp']);
	}
	// Resulting form
	$content['accounts']['forms']['add_account_form'] = $add_account_form->result();


	// Add alias - Form + POST
	$add_alias_form = new FormMaker("add_alias", genlink("page=accounts|domain_id=$domain_id"));
	$add_alias_form->add_element("source", "text", "custom|$reg_account", 1);
	$add_alias_form->set_display_name("source", "Source");
	$add_alias_form->add_input_desc("source", "@".$content['accounts']['details']['domain']['name']);
	$add_alias_form->add_element("destinations", "textarea", "free", 1);
	$add_alias_form->set_display_name("destinations", "Destination emails");
	$add_alias_form->add_element("policy_id", "select", "monoselect|$policy_select", 1);
	$add_alias_form->set_display_name("policy_id", "Scan policy");

	// POST
	if ($_POST['add_alias']) {
		$add_alias_form->check_post($_POST);

		// Check destinations from POST first !
		$destinations = explode("\n", $_POST['destinations']);
		foreach ($destinations as $destination) {
			$destination = trim($destination);
			if (!filter_var($destination, FILTER_VALIDATE_EMAIL)) {
				$add_alias_form->set_error("destinations");
			} else {
				$add_destinations[] = $destination;
			}
		}

		if (!$add_alias_form->errors()) {
			$form_results = $add_alias_form->get_values();

			// Fix domain id
			$form_results['domain_id'] = $domain_id;
			$new_user_id = $cnx->insert($form_results, "virtual_aliases");
			if (is_valid_id($new_user_id)) {

				// Add new aliases
				foreach ($add_destinations as $destination) {
					$cnx->insert( array('alias_id' => $new_user_id, 'destination' => $destination), 'virtual_alias_destinations');
				}

				$content['status'][] = "Alias <strong>".$form_results['source']."</strong> added";
				// Reset vals
				$add_alias_form->set_value("source", "");
				$add_alias_form->set_value("destinations", "");
			} else {
				$content['errors'][] = "Error while adding new alias";
				$content['errors'][] = $new_user_id;
			}

		} else {
			$content['errors'][] = "Form contains errors";
		}
	}
	// Resulting form
	$content['accounts']['forms']['add_alias_form'] = $add_alias_form->result();


	// Add ML - Form + POST - FIXME this is highly experimental
	if (domain_can_ml($domain_id)) {
		$add_ml_form = new FormMaker("add_ml", genlink("page=accounts|domain_id=$domain_id"));
		$add_ml_form->add_element("ml", "text", "custom|$reg_account", 1);
		$add_ml_form->set_display_name("ml", "Mailing List");
		$add_ml_form->add_input_desc("ml", "@".$content['accounts']['details']['domain']['name']);
		// POST
		if ($_POST['add_ml']) {
			$add_ml_form->check_post($_POST);
			if (!$add_ml_form->errors()) {
				$form_results = $add_ml_form->get_values();
				// Fix domain id
				$form_results['domain_id'] = $domain_id;
				$form_results['transport'] = "mlmmj"; // Hard-coded transport... for now.
				$new_user_id = $cnx->insert($form_results, "virtual_mailing_lists");
				if (is_valid_id($new_user_id)) {
					$content['status'][] = "ML <strong>".$form_results['source']."</strong> added";

					// This doesn't work, it's an interactive script - TODO someday, take this apart and make it usable here
					//$output = shell_exec('mlmmj-make-ml -s /home/mlmmj/'.$content['accounts']['details']['domain']['name'].' -L '.$form_results['ml'].' -c mailboy');
					$content['status'][] = 'You need to execute: mlmmj-make-ml -s /home/mlmmj/'.$content['accounts']['details']['domain']['name'].' -L '.$form_results['ml'].' -c mailboy';

					// Reset vals
					$add_ml_form->set_value("ml", "");
					//$add_ml_form->set_value("destination", "");
				} else {
					$content['errors'][] = "Error while adding new ML";
					$content['errors'][] = $new_user_id;
				}

			} else {
				$content['errors'][] = "Form contains errors";
			}
		}
		// Resulting form
		$content['accounts']['forms']['add_ml_form'] = $add_ml_form->result();
	}
}


// List accounts
$order_stuff = check_order_by('accounts');
$order_by = $order_stuff['order_by'];
$content['accounts']['list']['accounts']['order_by'] = $order_stuff['th'];
$content['accounts']['list']['accounts']['users'] = $cnx->select("*", "view_users", "WHERE `domain_id` ='$domain_id' $order_by");
if (is_array($content['accounts']['list']['accounts']['users'])) {
	foreach ($content['accounts']['list']['accounts']['users'] as $k => $v) {
		unset($content['accounts']['list']['accounts']['users'][$k]['password']);
		if (am_i_admin_of($domain_id)) {
			$content['accounts']['list']['accounts']['users'][$k]['delete_link'] = genlink("page=accounts|domain_id=$domain_id|delete_account=".$v['uid']."");
			$content['accounts']['list']['accounts']['users'][$k]['details_link'] = genlink("page=account_details|uid=".$v['uid']."");
		}
	}
}

// List aliases
$order_stuff = check_order_by('aliases');
//$order_by = $order_stuff['order_by'];
$content['accounts']['list']['aliases']['order_by'] = $order_stuff['th'];

//$content['accounts']['list']['aliases']['users'] = $cnx->select("*", "view_aliases", "WHERE `domain_id` ='$domain_id' $order_by");
$content['accounts']['list']['aliases']['users'] = $cnx->select("*", "virtual_aliases", "WHERE `domain_id` ='$domain_id'");

if (is_array($content['accounts']['list']['aliases']['users'])) {
	foreach ($content['accounts']['list']['aliases']['users'] as $k => $v) {

		// Add destinations of the alias
		$tmp_destinations = $cnx->select_row2("destination", "virtual_alias_destinations", "WHERE `alias_id` = '".$v['id']."'");
		$tmp_destinations = implode( "<br/>", $tmp_destinations);
		$content['accounts']['list']['aliases']['users'][$k]['destination'] = $tmp_destinations;

		//unset($content['accounts']['list']['aliases']['users'][$k]['password']);
		if (am_i_admin_of($domain_id)) {
			$content['accounts']['list']['aliases']['users'][$k]['delete_link'] = genlink("page=accounts|domain_id=$domain_id|delete_alias=".$v['id']."");
			$content['accounts']['list']['aliases']['users'][$k]['details_link'] = genlink("page=account_details|alias_id=".$v['id']."");
		}
	}

	// sorting inline...
	$content['accounts']['list']['aliases']['users'] = sort_array_by_sub_key($content['accounts']['list']['aliases']['users']
	, $order_stuff['order_key'], $order_stuff['asc']);
}

// List MLs
if (domain_can_ml($domain_id)) {
	$order_stuff = check_order_by('ml');
	$order_by = $order_stuff['order_by'];
	$content['accounts']['list']['ml']['order_by'] = $order_stuff['th'];
	$content['accounts']['list']['ml']['lists'] = $cnx->select("*", "view_mailing_lists", "WHERE `domain_id` ='$domain_id' $order_by");
	if (is_array($content['accounts']['list']['ml']['lists'])) {
		foreach ($content['accounts']['list']['ml']['lists'] as $k => $v) {
			if (am_i_admin_of($domain_id)) {
				$content['accounts']['list']['ml']['lists'][$k]['delete_link'] = genlink("page=accounts|domain_id=$domain_id|delete_ml=".$v['id']."");
				$content['accounts']['list']['ml']['lists'][$k]['details_link'] = genlink("page=account_details|ml_id=".$v['id']."");
			}
		}
	}
}

?>
