<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/


// Delete what needs to be deleted
if (is_valid_id($_GET['delete'])) {
	// ask for confirmation - verify rights
	if (is_valid_id($_GET['delete'])) {
		if (am_i_admin_of($_GET['delete'])) {
			$deleted_domain = $cnx->select_field("name", "virtual_domains", "WHERE `id` = '".$_GET['delete']."'");
			if ($deleted_domain) {
				$content['domains']['confirm_delete']['domain'] = $deleted_domain;
				$content['domains']['confirm_delete']['confirm_link'] = genlink("page=domains|delete=".$_GET['delete']."|confirm=1");
				$content['domains']['confirm_delete']['cancel_link'] = genlink("page=domains");
				if ($_GET['confirm'] == 1) {
					$cnx->delete($_GET['delete'], "virtual_domains", "id");
					$content['status'][] = "Domain <strong>$deleted_domain</strong> deleted";
					unset($content['domains']['confirm_delete']);
				}
			} else {
				$content['errors'][] = "You may not delete this domain";
			}
		} else {
			$content['errors'][] = "You may not delete this domain";
		}
	}
}


// Add new domain: Form + POST
if (am_i_server_admin()) {
	// Generate form to add new domains
	$add_domain_form = new FormMaker("new_domain", genlink("page=domains"));

	$add_domain_form->add_element("name", "text", "custom|$reg_domain", 1);
	$add_domain_form->set_display_name("name", "Domain");

	// Policies
	$policies_array = $cnx->select(array('id', 'policy_name'), "policy");
	foreach ($policies_array as $k => $v) {
		$policy_select .= $v['id']."=".$v['policy_name'].":";
	}
	$add_domain_form->add_element("default_policy", "select", "monoselect|$policy_select", 1);
	$add_domain_form->set_display_name("default_policy", "Default scan policy");

	$add_domain_form->add_element("default_quota_kb", "text", "integer|127");
	$add_domain_form->set_display_name("default_quota_kb", "Default quota");
	$add_domain_form->add_input_desc("default_quota_kb", " MB");

	$add_domain_form->add_element("default_mail", "checkbox", "bool");
	$add_domain_form->set_display_name("default_mail", "Default email");
	$add_domain_form->set_value("default_mail", "1");

	$add_domain_form->add_element("default_xmpp", "checkbox", "bool");
	$add_domain_form->set_display_name("default_xmpp", "Default XMPP");
	$add_domain_form->set_value("default_xmpp", "1");

	// POST
	if ($_POST['new_domain']) {
		$add_domain_form->check_post($_POST);
		if (!$add_domain_form->errors()) {
			// Add domain
			$add_domain_vars = $add_domain_form->get_values();
			$add_domain_vars['default_quota_kb'] = $add_domain_vars['default_quota_kb'] * 1024;

			// Fix bool vars that are unset/empty -> 0
			foreach($add_domain_vars AS $k => $v) {
				if (in_array($k, array('default_mail', 'default_xmpp')) AND empty($v)) {
					$add_domain_vars[$k] = 0;
				}
			}

			$r = $cnx->insert($add_domain_vars, "virtual_domains");
			if (is_valid_id($r)) {
				// Reset form - reset only "name", other vars can stay
				$add_domain_form->set_value("name", "");
				$content['status'][] = "Domain <strong>".$add_domain_vars['name']."</strong> added";
			} else {
				$content['errors'][] = $r;
			}
		} else {
			$content['errors'][] = 'Domain name contains errors1!!';
		}
	}
	// Result
	$content['domains']['forms']['add_domain_form'] = $add_domain_form->result();
}

// Generate list of domains
$order_stuff = check_order_by('domains');
$order_by = $order_stuff['order_by'];
$content['domains']['list']['order_by'] = $order_stuff['th'];
$content['domains']['list']['domains'] = $cnx->select("*", "view_domains", $order_by);
foreach ($content['domains']['list']['domains'] as $k => $v) {
	if (am_i_admin_of($v['id'])) {
		$content['domains']['list']['domains'][$k]['delete_link'] = genlink("page=domains|delete=".$v['id']."");
		$content['domains']['list']['domains'][$k]['details_link'] = genlink("page=accounts|domain_id=".$v['id']."");
	} else if (am_i_server_admin(2)) {
		$content['domains']['list']['domains'][$k]['details_link'] = genlink("page=accounts|domain_id=".$v['id']."");
	} else if (!am_i_server_admin(1)) {
		unset($content['domains']['list']['domains'][$k]);
	}
}

?>
