<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/
?>

<?php // CONFIRM DELETE ?>
<?php if ($content['policies']['confirm_delete']) { ?>
	<div id="confirm-delete">
		<p>Do you really want to delete the policy <strong><?php echo $content['policies']['confirm_delete']['policy']; ?></strong> ?
			<a href="<?php echo $content['policies']['confirm_delete']['confirm_link']; ?>">Yes</a>
			<a href="<?php echo $content['policies']['confirm_delete']['cancel_link']; ?>">No</a>
		</p>
	</div>
<?php } ?>

<?php if ($content['policies']['forms']['edit_policy']) { ?>
	<fieldset>
		<legend>Edit policy</legend>
	<?php	$edit_policy_form = new FormPrinter($content['policies']['forms']['edit_policy']);
		$edit_policy_form->configure_css("input", "input-text");
		$edit_policy_form->configure_css("submit", "input-submit");
		$edit_policy_form->auto_generate_form();
		$edit_policy_form->print_form("Edit policy"); ?>
	</fieldset>
<?php } else if ($content['policies']['forms']['add_policy'] AND $content['policies']['forms']['add_policy']['errors']) { ?>
	<fieldset>
		<legend>Add policy</legend>
	<?php	$add_policy_form = new FormPrinter($content['policies']['forms']['add_policy']);
		$add_policy_form->configure_css("input", "input-text");
		$add_policy_form->configure_css("submit", "input-submit");
		$add_policy_form->auto_generate_form();
		$add_policy_form->print_form("Add new policy"); ?>
	</fieldset>
<?php } ?>


<?php // List policies ?>
<?php if (is_array($content['policies']['list']['policies'])) { ?>
<div class="table" id="policy-list">
	<div class="table-row">
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['policy_name']; ?>#policy-list">Name</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['virus_lover']; ?>#policy-list">virus lover</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['spam_lover']; ?>#policy-list">spam lover</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['banned_files_lover']; ?>#policy-list">banned files lover</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['bad_header_lover']; ?>#policy-list">bad header lover</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['bypass_virus_checks']; ?>#policy-list">bypass virus checks</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['bypass_spam_checks']; ?>#policy-list">bypass spam checks</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['bypass_banned_checks']; ?>#policy-list">bypass banned checks</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['bypass_header_checks']; ?>#policy-list">bypass header checks</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['spam_modifies_subj']; ?>#policy-list">spam modifies subj</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['spam_quarantine_to']; ?>#policy-list">spam quarantine to</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['spam_tag_level']; ?>#policy-list">spam tag level</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['spam_tag2_level']; ?>#policy-list">spam tag2 level</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['policies']['list']['order_by']['spam_kill_level']; ?>#policy-list">spam kill level</a></div>
		<div class="table-cell table-th">Delete</div>
	</div>
	<?php foreach ($content['policies']['list']['policies'] as $k => $v) { ?>
		<div class="table-row">
			<div class="table-cell title">
				<?php if ($v['details_link']) { ?>
				<a href="<?php echo $v['details_link']; ?>"><?php echo $v['policy_name']; ?></a>
				<?php } else { ?>
				<?php echo $v['policy_name']; ?>
				<?php } ?>
			</div>
			<div class="table-cell"><span class="hidden">virus_lover</span><span><?php echo $v['virus_lover']; ?></span></div>
			<div class="table-cell"><span class="hidden">spam_lover</span><span><?php echo $v['spam_lover']; ?></span></div>
			<div class="table-cell"><span class="hidden">banned_files_lover</span><span><?php echo $v['banned_files_lover']; ?></span></div>
			<div class="table-cell"><span class="hidden">bad_header_lover</span><span><?php echo $v['bad_header_lover']; ?></span></div>
			<div class="table-cell"><span class="hidden">bypass_virus_checks</span><span><?php echo $v['bypass_virus_checks']; ?></span></div>
			<div class="table-cell"><span class="hidden">bypass_spam_checks</span><span><?php echo $v['bypass_spam_checks']; ?></span></div>
			<div class="table-cell"><span class="hidden">bypass_banned_checks</span><span><?php echo $v['bypass_banned_checks']; ?></span></div>
			<div class="table-cell"><span class="hidden">bypass_header_checks</span><span><?php echo $v['bypass_header_checks']; ?></span></div>
			<div class="table-cell"><span class="hidden">spam_modifies_subj</span><span><?php echo $v['spam_modifies_subj']; ?></span></div>
			<div class="table-cell"><span class="hidden">spam_quarantine_to</span><span><?php echo $v['spam_quarantine_to']; ?></span></div>
			<div class="table-cell"><span class="hidden">spam_tag_level</span><span><?php echo $v['spam_tag_level']; ?></span></div>
			<div class="table-cell"><span class="hidden">spam_tag2_level</span><span><?php echo $v['spam_tag2_level']; ?></span></div>
			<div class="table-cell"><span class="hidden">spam_kill_level</span><span><?php echo $v['spam_kill_level']; ?></span></div>
			<div class="table-cell delete">
			<?php if ($v['delete_link']) { ?>
				<a href="<?php echo $v['delete_link']; ?>">delete</a>
			<?php } ?>
			</div>
		</div>
	<?php } ?>
</div>
<?php } ?>



<?php if ($content['policies']['forms']['add_policy'] AND !$content['policies']['forms']['add_policy']['errors']) { ?>
	<fieldset>
		<legend>Add policy</legend>
	<?php	$add_policy_form = new FormPrinter($content['policies']['forms']['add_policy']);
		$add_policy_form->configure_css("input", "input-text");
		$add_policy_form->configure_css("submit", "input-submit");
		$add_policy_form->auto_generate_form();
		$add_policy_form->print_form("Add new policy"); ?>
	</fieldset>
<?php } ?>


