<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>Mailboy - For adminning your mail</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta name="author" content="Emmanuel Revah" />
	<link rel="stylesheet" type="text/css" media="all" href="<?php echo $cfg['siteroot']."/templates/".$cfg['template']."/css/style.css"; ?>" />
	<link rel="stylesheet" type="text/css" media="all" href="<?php echo $cfg['siteroot']."/templates/".$cfg['template']."/css/tables.css"; ?>" />
</head>
<body>

<div id="topdeco"></div>

<div class="wrapper">

	<div id="top">

		<h1 id="logo"><a href="<?php echo genlink(); ?>"><span class="hidden">Mailboy</span></a></h1>

		<?php if (am_i_user()) { ?>
		<div id="userinfo">
			<form id="logout" action="" method="post" enctype="multipart/form-data">
				<input class="input-submit" type="submit" name="logout" value="Logout" />
			</form>

			<strong><?php echo $_SESSION[login][email]; ?></strong>
			<?php if ($_SESSION[login][admin] == 1) { ?>
			<p>role: server admin</p>
			<?php } elseif ($_SESSION[login][admin_of]) { ?>
			<p>role: domain admin</p>
			<?php } ?>
		</div>
		<?php } ?>

		<div class="clear"></div>
	</div>


	<div id="menu">
		<ul>
		<?php foreach ($content['menu'] as $k => $v) {
			if ($v['menu']) { ?>
			<li <?php if ($v['active']) { echo 'class="active"'; } ?>><a href="<?php echo $v['link']; ?>"><?php echo $v['title']; ?></a></li>
			<?php }
		} ?>
		</ul>
		<div class="clear"></div>
	</div>

	<?php if ($content[errors]) { ?>
		<div id="errors">
			<h3>Errors</h3>
			<ul>
			<?php foreach ($content[errors] as $k => $v) {
				if (!empty($v)) { ?>
				<li><?php echo $v; ?></li>
				<?php }
			} ?>
			</ul>
		</div>
	<?php } ?>

	<?php if ($content[status]) { ?>
		<div id="status">
			<h3>Status</h3>
			<ul>
			<?php foreach ($content[status] as $k => $v) {
				if (!empty($v)) { ?>
				<li><?php echo $v; ?></li>
				<?php }
			} ?>
			</ul>
		</div>
	<?php } ?>

	<div id="main">
		<?php // !! this would be the main content !!
		if ($page) {
			require_once("templates/".$cfg['template']."/$page.php");
		} else {  ?>
		<p>Mailboy is a web interface for administrating email accounts. It uses a setup with Postfix, Dovecot and Amavis (among other softwares). The actual server setup
		is based on the ISP Style mail server tutorial that you can find <a href="http://workaround.org/ispmail/lenny/">here</a>. However there are quite a few modifications
		to the Workaround setup.</p>
		<?php } ?>

		<div class="clear"></div>
	</div>

</div>

	<div id="footer">
		<div class="wrapper">
			<small><a href="http://mailboy.manurevah.com/">Mailboy - version <?php echo $mailboy_version; ?></a></small>
		</div>
	</div>
	<?php //print_array($content); ?>
</body>
</html>
