<?php
/*
This file is part of Mailboy.

Mailboy is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Mailboy is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Mailboy.  If not, see <http://www.gnu.org/licenses/>.
*/
?>


<?php // CONFIRM DELETE ?>
<?php if ($content['domains']['confirm_delete']) { ?>
	<div id="confirm-delete">
		<p>Do you really want to delete the domain <strong><?php echo $content['domains']['confirm_delete']['domain']; ?></strong> ?
			<a href="<?php echo $content['domains']['confirm_delete']['confirm_link']; ?>">Yes</a>
			<a href="<?php echo $content['domains']['confirm_delete']['cancel_link']; ?>">No</a>
		</p>
	</div>
<?php } ?>


<?php if ($content['domains']['forms']['add_domain_form']['errors']) { // Display the form before the list if it has been posted and needs to be fixed ?>
	<fieldset>
		<legend>Add domain</legend>
	<?php	$add_domain_form = new FormPrinter($content['domains']['forms']['add_domain_form'], genlink("page=domains"));
		$add_domain_form->configure_css("input", "input-text");
		$add_domain_form->configure_css("submit", "input-submit");
		$add_domain_form->auto_generate_form($content['domains']['forms']['add_domain_form']['fields']);
		$add_domain_form->print_form("Add new domain"); ?>
	</fieldset>
<?php } ?>


<?php // list domains ?>
<?php if (is_array($content['domains']['list']['domains'])) { ?>
<div class="table" id="domain-list">
	<div class="table-row">
		<div class="table-cell table-th"><a href="<?php echo $content['domains']['list']['order_by']['name']; ?>#domain-list">Domain</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['domains']['list']['order_by']['default_quota']; ?>#domain-list">Default quota (MB)</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['domains']['list']['order_by']['default_mail']; ?>#domain-list">Default email</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['domains']['list']['order_by']['default_xmpp']; ?>#domain-list">Default XMPP</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['domains']['list']['order_by']['accounts']; ?>#domain-list">Accounts</a></div>
		<div class="table-cell table-th"><a href="<?php echo $content['domains']['list']['order_by']['aliases']; ?>#domain-list">Aliases</a></div>
		<div class="table-cell table-th">Delete</div>
	</div>
	<?php foreach ($content['domains']['list']['domains'] as $k => $v) { ?>
		<div class="table-row">
			<div class="table-cell title">
				<?php if ($v['details_link']) { ?>
				<a href="<?php echo $v['details_link']; ?>"><?php echo $v['name']; ?></a>
				<?php } else { ?>
				<?php echo $v['name']; ?>
				<?php } ?>
			</div>
			<div class="table-cell hidden"><span class="hidden">Default quota</span><span><?php echo ($v['default_quota'] / 1024); ?></span></div>
			<div class="table-cell hidden"><span class="hidden">Default email</span><span><?php echo $v['default_mail']; ?></span></div>
			<div class="table-cell hidden"><span class="hidden">Default XMPP</span><span><?php echo $v['default_xmpp']; ?></span></div>
			<div class="table-cell"><span class="hidden">Accounts</span><span><?php echo $v['accounts']; ?></span></div>
			<div class="table-cell"><span class="hidden">Aliases</span><span><?php echo $v['aliases']; ?></span></div>
			<div class="table-cell delete">
			<?php if ($v['delete_link']) { ?>
				<a href="<?php echo $v['delete_link']; ?>">delete</a>
			<?php } ?>
			</div>
		</div>
	<?php } ?>
</div>
<?php } ?>


<?php // NEW ADD DOMAIN FORM ?>
<?php if ($content['domains']['forms']['add_domain_form'] AND !$content['domains']['forms']['add_domain_form']['errors']) { // Don't display this form if it is displayed above ?>
	<fieldset>
		<legend>Add domain</legend>
	<?php	$add_domain_form = new FormPrinter($content['domains']['forms']['add_domain_form'], genlink("page=domains"));
		$add_domain_form->configure_css("input", "input-text");
		$add_domain_form->configure_css("submit", "input-submit");
		$add_domain_form->auto_generate_form($content['domains']['forms']['add_domain_form']['fields']);
		$add_domain_form->print_form("Add new domain"); ?>
	</fieldset>
<?php } ?>
